org.apache.poi.hslf.record

## Class HeadersFootersAtom

- java.lang.Object
- - org.apache.poi.hslf.record.Record
  - - org.apache.poi.hslf.record.RecordAtom
    - - org.apache.poi.hslf.record.HeadersFootersAtom

- All Implemented Interfaces:
    GenericRecord

      public final class HeadersFootersAtom
      extends RecordAtom

  An atom record that specifies options for displaying headers and footers on a presentation slide or notes slide.
  Author:
    Yegor Kozlov

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `HeadersFootersAtom.FormatIndex` FormatIndex enum without LCID mapping

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `fHasDate` A bit that specifies whether the date is displayed in the footer.
    `static int` | `fHasFooter` bit that specifies whether the footer text is displayed.
    `static int` | `fHasHeader` bit that specifies whether the header text is displayed.
    `static int` | `fHasSlideNumber` A bit that specifies whether the slide number is displayed in the footer.
    `static int` | `fHasTodayDate` A bit that specifies whether the current datetime is used for displaying the datetime.
    `static int` | `fHasUserDate` A bit that specifies whether the date specified in UserDateAtom record is used for displaying the datetime.

    - ### Fields inherited from class org.apache.poi.hslf.record.Record

      `logger`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `HeadersFootersAtom()` Create a new instance of `HeadersFootersAtom`
    `protected` | `HeadersFootersAtom(byte[] source, int start, int len)` Build an instance of `HeadersFootersAtom` from on-disk data

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `getFlag(int bit)`
    `int` | `getFormatId()` A signed integer that specifies the format ID to be used to style the datetime.
    `java.util.Map<java.lang.String,java.util.function.Supplier<?>>` | `getGenericProperties()`
    `int` | `getMask()` A bit mask specifying options for displaying headers and footers A - `fHasDate` (1 bit): A bit that specifies whether the date is displayed in the footer.
    `long` | `getRecordType()` Returns the type (held as a little endian in bytes 3 and 4) that this class handles
    `void` | `setFlag(int bit, boolean value)`
    `void` | `setFormatId(int formatId)` A signed integer that specifies the format ID to be used to style the datetime.
    `void` | `setMask(int mask)` A bit mask specifying options for displaying headers and footers
    `java.lang.String` | `toString()`
    `void` | `writeOut(java.io.OutputStream out)` Write the contents of the record back, so it can be written to disk

    - ### Methods inherited from class org.apache.poi.hslf.record.RecordAtom

      `getChildRecords, isAnAtom`

    - ### Methods inherited from class org.apache.poi.hslf.record.Record

      `buildRecordAtOffset, createRecordForType, findChildRecords, getGenericChildren, getGenericRecordType, writeLittleEndian, writeLittleEndian`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### fHasDate

          public static final int fHasDate

      A bit that specifies whether the date is displayed in the footer.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

    - #### fHasTodayDate

          public static final int fHasTodayDate

      A bit that specifies whether the current datetime is used for displaying the datetime.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

    - #### fHasUserDate

          public static final int fHasUserDate

      A bit that specifies whether the date specified in UserDateAtom record is used for displaying the datetime.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

    - #### fHasSlideNumber

          public static final int fHasSlideNumber

      A bit that specifies whether the slide number is displayed in the footer.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

    - #### fHasHeader

          public static final int fHasHeader

      bit that specifies whether the header text is displayed.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

    - #### fHasFooter

          public static final int fHasFooter

      bit that specifies whether the footer text is displayed.
      See Also:
        `getMask()`, `setMask(int)`, Constant Field Values

  - ### Constructor Detail

    - #### HeadersFootersAtom

          protected HeadersFootersAtom(byte[] source,
                                       int start,
                                       int len)

      Build an instance of `HeadersFootersAtom` from on-disk data

    - #### HeadersFootersAtom

          public HeadersFootersAtom()

      Create a new instance of `HeadersFootersAtom`

  - ### Method Detail

    - #### getRecordType

          public long getRecordType()

      Description copied from class: `Record`
      Returns the type (held as a little endian in bytes 3 and 4) that this class handles
      Specified by:
        `getRecordType` in class `Record`

    - #### writeOut

          public void writeOut(java.io.OutputStream out)
                        throws java.io.IOException

      Write the contents of the record back, so it can be written to disk
      Specified by:
        `writeOut` in class `Record`
      Throws:
        `java.io.IOException`

    - #### getFormatId

          public int getFormatId()

      A signed integer that specifies the format ID to be used to style the datetime.

      It MUST be in the range [0, 12]. This value is converted into a string as specified by the index field of the DateTimeMCAtom record. It MUST be ignored unless fHasTodayDate is TRUE.

      Returns:
        A signed integer that specifies the format ID to be used to style the datetime.

    - #### setFormatId

          public void setFormatId(int formatId)

      A signed integer that specifies the format ID to be used to style the datetime.
      Parameters:
        `formatId` - A signed integer that specifies the format ID to be used to style the datetime.

    - #### getMask

          public int getMask()

      A bit mask specifying options for displaying headers and footers
    - A - `fHasDate` (1 bit): A bit that specifies whether the date is displayed in the footer.
    - B - `fHasTodayDate` (1 bit): A bit that specifies whether the current datetime is used for displaying the datetime.
    - C - `fHasUserDate` (1 bit): A bit that specifies whether the date specified in UserDateAtom record is used for displaying the datetime.
    - D - `fHasSlideNumber` (1 bit): A bit that specifies whether the slide number is displayed in the footer.
    - E - `fHasHeader` (1 bit): A bit that specifies whether the header text specified by HeaderAtom record is displayed.
    - F - `fHasFooter` (1 bit): A bit that specifies whether the footer text specified by FooterAtom record is displayed.
    - reserved (10 bits): MUST be zero and MUST be ignored.

Returns:
  A bit mask specifying options for displaying headers and footers

- #### setMask

      public void setMask(int mask)

  A bit mask specifying options for displaying headers and footers
  Parameters:
    `mask` - A bit mask specifying options for displaying headers and footers

- #### getFlag

      public boolean getFlag(int bit)

  Parameters:
    `bit` - the bit to check
  Returns:
    whether the specified flag is set

- #### setFlag

      public void setFlag(int bit,
                          boolean value)

  Parameters:
    `bit` - the bit to set
    `value` - whether the specified bit is set

- #### toString

      public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

- #### getGenericProperties

      public java.util.Map<java.lang.String,java.util.function.Supplier<?>> getGenericProperties()

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.